/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERVPADR                                                 */
/* Tabela : SERVPADR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SERVPADR
BEFORE INSERT OR UPDATE OR DELETE
ON SERVPADR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSRVP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSERVPADR,0) <> NVL(:NEW.CDSERVPADR,0)) OR
         (NVL(:OLD.NMSERVPADR,0) <> NVL(:NEW.NMSERVPADR,0)) OR
         (NVL(:OLD.CDPRODUTO,0)  <> NVL(:NEW.CDPRODUTO,0)) THEN
         :NEW.DTULTATUSRVP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SERVPADR', '', 'CDSERVPADR='||:OLD.CDSERVPADR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SERVPADR MODIFY DTULTATUSRVP DEFAULT SYSDATE
/
