<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 14/03/2016
 * Time: 17:30
 */

namespace Zeedhi\DevOps\Util;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use Zeedhi\DevOps\Model\Util\LogicalDeleted AS ModelLogicalDeleted;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

class Utilities
{
    const ID_CLIENTE_LIBRARIES = "cd7e85178153by60953518945f9hakt19a50a4";
    const SECRET_CLIENTE_LIBRARIES = "lib5449996c21f780fe30badd6521931a5sac9";

    //Entity Paths
    const SERVER_MANAGER_ENTITY_DIR = '\Zeedhi\DevOps\Model\Servermanager\Entities\\';
    const CONFIGURATION_MANAGER_ENTITY_DIR = '\Zeedhi\DevOps\Model\Configurationmanager\Entities\\';
    const PROFILE_ENTITY_DIR = '\Zeedhi\DevOps\Model\Profile\Entities\\';
    const DEVOPS_ENTITY_DIR = '\Zeedhi\DevOps\Model\Devops\Entities\\';
    const PROJECT_MANAGEMENT_ENTITY_DIR = '\Zeedhi\DevOps\Model\Projectmanagement\Entities\\';

    //Is Active Values
    const IS_ACTIVE_YES = 'Y';
    const IS_ACTIVE_NO = 'N';
    const IS_ACTIVE_DELETED = 'D';

    const STATUS_ACTIVE = 'A';
    const STATUS_NOT_ACTIVE = 'I';
    const STATUS_DELETED = 'D';

    //All
    CONST PREFIX_TEST_TASK = '[TST] - ';
    CONST TASK_STATUS_NOT_STARTED = 3;
    CONST PROJECT_STATUS_CONTROL_CONCLUDED = 'C';
    CONST PROJECT_STATUS_CONTROL_IN_HOMOLOGATION = 'O';

    const FORMAT_DATE_DEFAULT = 'd/m/Y H:i:s';
    const FORMAT_DATE_DEFAULT_ONLY_DATE = 'd/m/Y';
    /**
     * @param $filters
     * @param null $tableAlias
     * @return string
     */
    public static function createQueryFiltered($filters, $tableAlias = null)
    {

        $filterSQL = '';
        foreach ($filters as $filter) {
            $name = $filter['columnName'];
            $operator = $filter['operator'] == "LIKE_I" ? "LIKE" : $filter['operator'];
            $values = $filter['value'];
            if($name == 'NRLICENCAUSO'){
                $operator = 'LIKE';
            }
            //(!is_null($values) && $operator == '=') ->Gambi to fix framework bugs :(
            if ((($name != '*' && !empty($values)) || $values == 0) && !(empty($values) && $operator == '=') && !is_null($values)) {
                if ($operator == 'BETWEEN') {
                    if (!empty($values[0]) && !empty($values[1])) {
                        $values = "TO_DATE( '$values[0] 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')
                                AND TO_DATE( '$values[1] 23:59:59' ,'DD/MM/YYYY HH24:MI:SS')";
                    } else if (!empty($values[0])) {
                        $operator = '>';
                        $values = "TO_DATE( '$values[0] 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')";
                    } else if (!empty($values[1])) {
                        $operator = '<';
                        $values = "TO_DATE( '$values[1] 00:00:00' ,'DD/MM/YYYY HH24:MI:SS')";
                    } else {
                        $values = "";
                    }

                    if ($values || ($values && ($values[0] || $values[1]))) {
                        if (!empty($tableAlias)) {
                            $filterSQL .= "AND $tableAlias.$name $operator $values";
                        } else {
                            $filterSQL .= "AND $name $operator $values";
                        }
                    }
                } else {
                    if (is_array($values) && $operator != 'MAPPED_LIKE_ALL') {
                        $stringValues = "('" . implode($values, "','") . "')";
                        $values = $stringValues;
                    }
                    if ($operator == 'LIKE' || $operator == 'LIKE_I') {
                        $operator = 'LIKE';
                        if (!empty($tableAlias)) {
                            $values = "UPPER('" . $values . "')";
                            $name = "UPPER($tableAlias.$name)";
                        } else {
                            $values = "UPPER('" . $values . "')";
                            $name = "UPPER($name)";
                        }
                    }
                    if ($operator == 'LIKE_ALL') {
                        if (!empty($tableAlias)) {
                            $values = "UPPER('" . $values . "')";
                        } else {
                            $values = "UPPER('" . $values . "')";
                        }

                        $columnList = explode('|', $name);
                        $likes = array();
                        foreach ($columnList as $column) {
                            $likes[] = "UPPER($column) LIKE $values";
                        }
                        $filterLikeAll = implode($likes, ' OR ');
                        $filterSQL .= " AND ( $filterLikeAll )";
                    } else if ($operator == 'LIKE') {
                        $filterSQL .= " AND $name $operator $values ";
                    } else if ($operator == 'IS_NULL') {
                        if (!empty($tableAlias)) {
                            $filterSQL .= " AND $tableAlias.$name IS $values ";
                        } else {
                            $filterSQL .= " AND $name IS $values ";
                        }
                    } else if ($operator == '='){
                        if(!empty($tableAlias)){
                            $filterSQL .= " AND $tableAlias.$name $operator '$values' ";
                        } else {
                            $filterSQL .= " AND $name $operator '$values' ";
                        }
                    } else if ($operator == 'MAPPED_LIKE_ALL') {
                        foreach($values[0] as $index => $mappedLikeAllValues) {
                            if($index == '_ALL') {
                                $values = "UPPER('" . $mappedLikeAllValues . "')";

                                $columnList = explode('|', explode('#', $name)[0]);
                                $likes = array();
                                foreach ($columnList as $column) {
                                    if (empty($tableAlias)) {
                                        $likes[] = "UPPER($column) LIKE $values";
                                    } else {
                                        $likes[] = "UPPER($tableAlias.$column) LIKE $values";
                                    }
                                }
                                $filterLikeAll = implode($likes, ' OR ');
                                $filterSQL .= " AND ( $filterLikeAll )";
                            } else {
                                $stringValues = "('" . implode($mappedLikeAllValues, "','") . "')";
                                if (!empty($tableAlias)) {
                                    $filterSQL .= " AND $tableAlias.$index IN $stringValues ";
                                } else {
                                    $filterSQL .= " AND $index IN $stringValues ";
                                }
                            }
                        }
                    } else {
                        if (!empty($tableAlias)) {
                            $filterSQL .= " AND $tableAlias.$name $operator $values ";
                        } else {
                            $filterSQL .= " AND $name $operator $values ";
                        }
                    }
                }
            }
        }
        return $filterSQL;
    }

    public static function getFilterTableColumn($filters, $tableColumn)
    {
        $filterLabel = [];
        foreach ($filters as $filter) {
            if ($filter['columnName'] === $tableColumn) {
               $filterLabel =  array($filter);
            }
        }
        return $filterLabel;
    }

    //tasks status
    /**
     * @return Entities\TaskStatus
     */
    public static function getTaskStatusNotInitialized(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_NOT_INITIALIZED, 'isProject' => 'N' ));
    }
    /**
     * @return Entities\TaskStatus
     */
    public static function getTaskStatusIsDeveloping(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_IN_DEVELOPING, 'isProject' => 'N' ));
    }
    /**
     * @return Entities\TaskStatus
     */
    public static function getTaskStatusPaused(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_PAUSED, 'isProject' => 'N' ));
    }

    /**
     * @return Entities\TaskStatus
     */
    public static function getTaskStatusIsConcluded(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_CONCLUDED, 'isProject' => 'N' ));
    }
    /**
     * @return Entities\TaskStatus
     */
    public static function getTaskStatusHomologated(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_HOMOLOGATED, 'isProject' => 'N' ));
    }

    //projects status
    /**
     * @return Entities\TaskStatus
     */
    public static function getProjectStatusPlanning(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_PLANNING, 'isProject' => 'Y' ));
    }
    /**
     * @return Entities\TaskStatus
     */
    public static function getProjectStatusProgress(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_PROGRESS, 'isProject' => 'Y' ));
    }

    public static function getDateNowString()
    {
        $date = new \DateTime();
        return $date->format(self::FORMAT_DATE_DEFAULT);
    }
    /**
     * @return Entities\TaskStatus
     */
    public static function getProjectStatusCanceled(){
        /** @var EntityManager $entityManager */
        $entityManager = self::getEntityManager();
        return $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus')
            ->findOneBy(array('control'=>Entities\TaskStatus::TASK_STATUS_CONTROL_CANCELED, 'isProject' => 'Y' ));
    }

    public static function searchForIndex($value, $array, $index = 'ID')
    {
        foreach ($array as $key => $val) {
            if ($val[$index] == $value) {
                return $key;
            }
        }
        return false;
    }

    public static function setSelectMultiInQuery($stringValue, $int = false, $delimiter = ',',$uniqueArray = false)
    {
        $array = self::getArrayByString($stringValue, $delimiter, $int);
        if($uniqueArray){
            $array = array_unique($array);
        }
        return $array;
    }

    public static function getArrayByString($stringValue, $delimiter = ',', $int = false)
    {
        if (empty($stringValue)) {
            $value = array();
        } else {
            if ($int) {
                $value = array_map('intval', explode($delimiter, $stringValue));
            } else {
                $value = explode($delimiter, $stringValue);
            }
        }
        return $value;
    }


    /**
     * @param $array
     * @param string $glue
     * @param string $start
     * @param string $end
     * @param string $default
     * @return string
     */
    public static function getStringForArray($array,$glue = ',',$start = '',$end = '',$default = ''){
        $return = $default;
        if(!empty($array)) {
            $return = $start . implode($glue, $array) . $end;
        }
        return $return;
    }


    public static function getStringForArrayWithDefault($array,$default = '',$glue = ',',$start = '',$end = ''){

        return self::getStringForArray($array,$glue,$start,$end,$default);
    }

    public static function maskCpfAndCnpj($val){
        $masked = '';
        if($val) {
            if (count($val) == 11) {
                $mask = '###.###.###-##';
            } else {
                $mask = '##.###.###/####-##';
            }
            $masked = self::mask($val, $mask);
        }
        return $masked;
    }

    public static function mask($val, $mask)
    {
        $masked = '';
        $k = 0;
        for($i = 0; $i<=strlen($mask)-1; $i++)
        {
            if($mask[$i] == '#')
            {
                if(isset($val[$k]))
                    $masked .= $val[$k++];
            }
            else
            {
                if(isset($mask[$i]))
                    $masked .= $mask[$i];
            }
        }
        return $masked;
    }

    public static function validateDocumentNumber($documentNumber)
    {
        if ($documentNumber) {
            return preg_replace("/[^0-9]/", "", $documentNumber);
        }
        return $documentNumber;
    }

    public static function setPeriodInQuery($begin, $end)
    {

        return array('start' => $begin, 'end' => $end, 'customized' => false);
    }

    public static function queryFilterTypeProjectMeeting($tableAlias = '', $not = false,$excludeTimeLine = true)
    {
        if ($not) {
            $not = 'NOT';
        } else {
            $not = '';
        }

        $meeting = Entities\ProjectType::TYPE_PROJECT_CONTROL_MEETING;
        $meetingOccurrences = Entities\ProjectType::TYPE_PROJECT_CONTROL_MEETING_OCCURRENCES;
        $timeLine = Entities\ProjectType::TYPE_PROJECT_CONTROL_TIME_LINE;
        $externalType = array($meeting,$meetingOccurrences);
        if($excludeTimeLine){
            $externalType[] = $timeLine;
        }
        $stringValues = "('" . implode($externalType, "','") . "')";
        return "AND $tableAlias.EXTERNALTYPE $not IN $stringValues AND $tableAlias.EXTERNALTYPE <> '" . $timeLine . "'";
    }

    public static function removeArrayEntities(EntityManager $entityManager, $arrayEntities = array()){
        foreach ($arrayEntities as $entity) {
            $entityManager->remove($entity);
        }
    }

    public static function getProjectLessId($projectId)
    {
        $query = <<<SQL
			SELECT ID
			FROM  PROJECT P
			WHERE P.PARENT = :project
SQL;

        $params = array(
            'project' => $projectId
        );
        return self::getEntityManager()->getConnection()->fetchAll($query, $params);
    }


    public static function executeFunction($object,$arrayMethod){
        foreach ($arrayMethod as $method) {
            $object = $object->$method();
        }
        return $object;
    }

    public static function getArrayByArrayObjectWithGet( array $arrayObject = array(),$arrayMethod = array('getId')){
        $array = array();
        foreach ($arrayObject as $object) {
            $array[] = self::executeFunction($object,$arrayMethod);
        }
        return $array;
    }

    public static function fixBugWhereINQuery(array $allProjectIds, $column, $isNotIn = false, $isString = false)
    {
        $arrays = array_chunk($allProjectIds, 900);
        $allProjectsString = '';
        $in = $isNotIn ? 'NOT IN' : 'IN';
        $connection = $isNotIn ? 'AND' : 'OR';
        if ($isString) {
            $glue = "','";
            $start = "'";
            $end = "'";
        } else {
            $glue = ',';
            $start = '';
            $end = '';
        }
        foreach ($arrays as $array) {
            $allProjectsString .= " $column $in (" . Utilities::getStringForArray($array, $glue, $start, $end) . ") $connection";
        }
        $allProjectsString .= " $column $in ($start 0 $end) ";
        return $allProjectsString;
    }

    public static function getAllProjectIdModelChildren($organization){

        $query = <<<SQL
                SELECT PRE.PROJECT AS ID
                  FROM PROJECT_RELATIONSHIP PRE
                  JOIN (  SELECT P.ID
                                  FROM PROJECT P
                                 WHERE P.ORGANIZATION = :organization
                                   AND P.STATUS = 'A'
                                 START WITH P.PARENT IN (SELECT PRO.ID
                                                           FROM PROJECT PRO
                                                           JOIN PROJECT_TYPE PRT ON(PRT.ID = PRO.PROJECT_TYPE)
                                                          WHERE PRT.EXTERNALTYPE = 'Q'
                                                            AND PRO.ORGANIZATION = :organization
                                                            AND PRO.STATUS = 'A')
                                                        CONNECT BY PRIOR P.ID = P.PARENT) PRM ON (PRE.PROJECT_RELATIONSHIP = PRM.ID)
                 WHERE PRE.TYPE = 'M'
SQL;
        $params = array(
            'organization' => $organization
        );
        return self::getArrayFromArrayAssociative(self::getEntityManager()->getConnection()->fetchAll($query, $params ));
    }
    public static function getAllProjectIdModel($organization){

        $query = <<<SQL
                SELECT P.ID
                FROM PROJECT P
                WHERE P.ORGANIZATION = :organization
                AND P.STATUS = 'A'
                START WITH P.PARENT IN ( SELECT PRO.ID
                                           FROM PROJECT PRO
                                           JOIN PROJECT_TYPE PRT ON(PRT.ID = PRO.PROJECT_TYPE)
                                          WHERE PRT.EXTERNALTYPE IN ( 'Q' , 'F' )
                                            AND PRO.ORGANIZATION = :organization
                                            AND PRO.STATUS = 'A')
                CONNECT BY PRIOR P.ID = P.PARENT
SQL;
        $params = array(
            'organization' => $organization,
        );
        return self::getArrayFromArrayAssociative(self::getEntityManager()->getConnection()->fetchAll($query, $params ));
    }


    public static function removeModels($products,$organization)
    {
        $modelProjectIds = self::getAllProjectIdModel($organization);
        $notModelProducts = array();
        foreach ($products as $product) {
            if (!in_array($product['ID'], $modelProjectIds)) {
                $notModelProducts[] = $product;
            }
        }
        return $notModelProducts;
    }

    public static function getAllProjectFromProjectParent($filter,$onlyProduct,$organization)
    {
        $filterHasProduct = '';
        if($onlyProduct){
            $filterHasProduct =  'AND PRT.EXTERNALTYPE IN(:controlHasProduct)';
        }
        $filterTypeProject = Utilities::queryFilterTypeProjectMeeting('PRT',true);
        $filterModel = "AND P.ID NOT IN (  SELECT PRO.ID
                                            FROM PROJECT PRO
                                            JOIN PROJECT_RELATIONSHIP PRE ON(PRE.PROJECT = PRO.ID AND TYPE = 'G')
                                            JOIN PROJECT PRM ON(PRM.ID = PRE.PROJECT_RELATIONSHIP AND PRM.STATUS = 'A')
                                            JOIN PROJECT_TYPE PRT ON(PRT.ID = PRM.PROJECT_TYPE)
                                           WHERE PRO.STATUS = 'A'
                                             AND PRT.EXTERNALTYPE = 'Q')";
        $query = <<<SQL
                SELECT P.ID
                FROM PROJECT P
                JOIN PROJECT_TYPE PRT ON(P.PROJECT_TYPE = PRT.ID)
                LEFT JOIN RESOURCE_PROJECT PARP ON(P.ID = PARP.PROJECT AND PARP.TYPE = 'M')
                WHERE $filter
                $filterHasProduct
                $filterTypeProject
                $filterModel
                AND P.ORGANIZATION = :organization
                AND P.STATUS = 'A'
SQL;

        $params = array(
            'controlHasProduct' => array(
                Entities\ProjectType::TYPE_PROJECT_CONTROL_PRODUCT,
                Entities\ProjectType::TYPE_PROJECT_CONTROL_MODEL_RESTRICTED,
                Entities\ProjectType::TYPE_PROJECT_CONTROL_MODEL_FREE,
            ),
            'organization' => $organization
        );
        $paramTypes = array(
            'controlHasProduct' => Connection::PARAM_STR_ARRAY
        );
        return self::getArrayFromArrayAssociative(self::getEntityManager()->getConnection()->fetchAll($query, $params ,$paramTypes));

    }

    public static function getAllStructureLessId($structureIds)
    {
        $structureString = '';
        foreach ($structureIds as $structureId) {
            $structureString .= $structureId['ID'].',';
        }
        $structureString .= '0';
        $query = <<<SQL
                SELECT P.ID
                FROM STRUCTURE P
                WHERE P.ID IN ($structureString)
                AND P.STATUS <> 'D'
                UNION ALL
                SELECT P.ID
                FROM STRUCTURE P
                WHERE P.STATUS <> 'D'
                START WITH P.PARENT IN ($structureString)
                CONNECT BY PRIOR P.ID = P.PARENT
SQL;
        return self::getEntityManager()->getConnection()->fetchAll($query);
    }
    public static function getAllProjectLessIdInArray($projectId){
        return self::getArrayFromArrayAssociative(self::getAllProjectLessId(array(array('ID' => $projectId))));
    }

    public static function getAllTaskInProjectIdInArray($projectId, $filter = ''){
        $query = <<<SQL
             SELECT TAS.ID
               FROM PROJECT P
               JOIN TASK TAS ON (TAS.PROJECT = P.ID)
          LEFT JOIN TASK_STATUS TST ON (TAS.TASK_STATUS = TST.ID AND TST.CONTROL = 'B')
              WHERE P.ID = $projectId
                AND P.STATUS = 'A'
                AND TAS.STATUS = 'A'
                AND TST.CONTROL IS NULL
                $filter
SQL;
        $task = self::getEntityManager()->getConnection()->fetchAll($query);
        return self::getArrayFromArrayAssociative($task);
    }
    public static function getAllTaskChildrenIdInArrayByCalc($taskId, $filter = ''){
        $query = <<<SQL
             SELECT P.ID
               FROM TASK P
          LEFT JOIN TASK_STATUS TST ON (P.TASK_STATUS = TST.ID AND TST.CONTROL = 'B')
              WHERE P.STATUS = 'A'
                AND TST.CONTROL IS NULL
              $filter
              START WITH P.PARENT IN ($taskId)
            CONNECT BY PRIOR P.ID = P.PARENT
SQL;
        $task = self::getEntityManager()->getConnection()->fetchAll($query);
        return self::getArrayFromArrayAssociative($task);
    }

    public static function getAllTaskChildrenIdInArray($taskId, $filter = ''){
        $query = <<<SQL
             SELECT P.ID
               FROM TASK P
              WHERE P.STATUS <> 'D'
              $filter
              START WITH P.PARENT IN ($taskId)
            CONNECT BY PRIOR P.ID = P.PARENT
SQL;
        $task = self::getEntityManager()->getConnection()->fetchAll($query);
        return self::getArrayFromArrayAssociative($task);
    }
    public static function getAllProjectLessIdIncludingHimByArray(array $projectIds){
        $query = <<<SQL
             SELECT P.ID
               FROM PROJECT P
              WHERE P.STATUS = :IS_ACTIVE
              START WITH P.ID IN (:PROJECT_IDS)
            CONNECT BY PRIOR P.ID = P.PARENT
SQL;

        $params = array(
            'IS_ACTIVE' => Entities\Project::IS_ACTIVE,
            'PROJECT_IDS' => $projectIds,
        );
        $paramTypes = array(
            'PROJECT_IDS' => Connection::PARAM_STR_ARRAY,
        );
        return self::getArrayFromArrayAssociative(self::getEntityManager()->getConnection()->fetchAll($query,$params,$paramTypes));
    }

    public static function getAllProjectChildrenIdInArray($projectId){
        $query = <<<SQL
             SELECT P.ID
               FROM PROJECT P
              WHERE P.STATUS <> 'D'
              START WITH P.PARENT IN ($projectId)
            CONNECT BY PRIOR P.ID = P.PARENT
SQL;
        $task = self::getEntityManager()->getConnection()->fetchAll($query);
        return self::getArrayFromArrayAssociative($task);
    }

    public static function getAllProjectChildrenNotCanceledAndNotConcludedIdInArray($projectId)
    {
        $query = <<<SQL
             SELECT P.ID
               FROM PROJECT P
               JOIN TASK_STATUS TS ON (TS.ID = P.PROJECT_STATUS AND TS.CONTROL NOT IN(:EXCLUDED_STATUS) )
              WHERE P.STATUS <> :STATUS_DELETED
              START WITH P.PARENT IN (:PROJECT_ID)
            CONNECT BY PRIOR P.ID = P.PARENT
SQL;
        $params = array(
            'STATUS_DELETED' => ModelLogicalDeleted::STATUS_LOGICAL_DELETED,
            'PROJECT_ID' => $projectId,
            'EXCLUDED_STATUS' => array(
                Entities\TaskStatus::TASK_STATUS_CONTROL_CONCLUDED,
                Entities\TaskStatus::TASK_STATUS_CONTROL_CANCELED,
            ),
        );
        $paramTypes = array(
            'EXCLUDED_STATUS' => Connection::PARAM_STR_ARRAY,
        );
        $task = self::getEntityManager()->getConnection()->fetchAll($query, $params, $paramTypes);
        return self::getArrayFromArrayAssociative($task);
    }

    public static function getStringSelectAllProjectManagerByUser($userId,$index = 'P.ID'){
        return "($index IN (SELECT ID FROM TABLE( PROJECT_BY_USER($userId,'Y','N'))))";
    }

    public static function getStringSelectAllProjectStructureManagerByUser($userId,$index = 'P.ID'){
        return "($index IN (SELECT ID FROM TABLE( PROJECT_BY_USER($userId,'N','Y'))))";
    }
    public static function getStringSelectAllProjectByUser($userId,$index = 'P.ID'){
        return "($index IN (SELECT ID FROM TABLE( PROJECT_BY_USER($userId))))";
    }

    public static function getAllProjectLessId($projectsId)
    {
        $projectsId = self::getArrayFromArrayAssociative($projectsId);
        $projectString = Utilities::fixBugWhereINQuery($projectsId,'P.ID');
        $parentProjectString = Utilities::fixBugWhereINQuery($projectsId,'P.PARENT');
        $query = <<<SQL
			 SELECT P.ID
               FROM PROJECT P
               LEFT JOIN TASK_STATUS PRS ON(PRS.ID = P.PROJECT_STATUS)
              WHERE ($projectString)
                AND PRS.CONTROL NOT IN (:controlCanceled, :controlConcluded, :controlHomologated)
                AND P.STATUS <> 'D'
              UNION ALL
             SELECT P.ID
               FROM PROJECT P
               LEFT JOIN TASK_STATUS PRS ON(PRS.ID = P.PROJECT_STATUS)
              WHERE P.STATUS <> 'D'
                AND PRS.CONTROL NOT IN (:controlCanceled, :controlConcluded, :controlHomologated)
              START WITH ($parentProjectString)
            CONNECT BY PRIOR P.ID = P.PARENT
SQL;
        $params = array(
            'controlCanceled'    => Entities\TaskStatus::TASK_STATUS_CONTROL_CANCELED,
            'controlConcluded'   => Entities\TaskStatus::TASK_STATUS_CONTROL_CONCLUDED,
            'controlHomologated' =>  Entities\TaskStatus::TASK_STATUS_CONTROL_HOMOLOGATED,
        );
        return self::getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public static function verifyShowMessage($dataSet) {
        $showMessage = true;

        foreach ($dataSet->getRows() as $row) {
            if(isset($row['isMessage']) && $row['isMessage'] === false) {
                $showMessage = false;
                break;
            }
        }

        return $showMessage;
    }

    /**
     * @param $array
     * @param String $key
     * @return array
     */
    public static function getArrayAssociativeFromArray( array $array = array(), $key = 'ID')
    {
        $result = array();
        foreach ($array as $row) {
            $result[][$key] = $row;
        }
        return $result;
    }/**
     * @param $array
     * @param String $key
     * @return array
     */
    public static function getArrayFromArrayAssociative( array $array = array(), $key = 'ID')
    {
        $result = array();
        foreach ($array as $row) {
            $result[] = $row[$key];
        }
        return $result;
    }

    public static function getChildrenProjectsIdByArray(array $projectIds)
    {
        $projectIdsArray = array();
        foreach ($projectIds as $projectId) {
            $projectIdsArray[] = array('ID' => $projectId);
        }
        if (!empty($projectIdsArray)) {
            return self::getChildrenProjectsId($projectIdsArray);
        } else {
            return '0';
        }
    }


    public static function getChildrenProjectsId($projectIds)
    {
        $projects = self::getAllProjectLessId($projectIds);
        if (sizeof(($projects)) > 0) {
            $projects = self::arrayAssociativeToArray($projects,'ID');
            $projectsIds = array_unique($projects);
            $projectsIdsString = implode(",", $projectsIds);
        } else {
            $projectsIdsString = "0";
        }

        return $projectsIdsString;
    }

    public static function arrayAssociativeToArray($arrayAssociative, $index = 'ID'){
        $array = array();
        foreach ($arrayAssociative as $value) {
            $array[] = $value[$index];
        }
        return $array;
    }

    public static function getDataGET($folder){
        return \DateTime::createFromFormat('YmdHis', $folder);

    }

    public static function arrayToAssociativeArray($array, $index = 'ID',$indexValue = 'VALUE'){
        $arrayAssociative = array();
        foreach ($array as $value) {
            $array[$value[$index]] = $value[$indexValue];
        }
        return $arrayAssociative;
    }

    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }

    public static function getFileServerFilesUrl()
    {
        return InstanceManager::getInstance()->getParameter('fileServerFilesUrl');
    }

    public static function getBaseUri()
    {
        return InstanceManager::getInstance()->getParameter('baseUri');
    }

    public static function getTemporaryDir()
    {
        return InstanceManager::getInstance()->getParameter('temporaryDir');
    }

    public static function getSmtpName()
    {
        return InstanceManager::getInstance()->getParameter('smtpName');
    }

    public static function getSmtpHost()
    {
        return InstanceManager::getInstance()->getParameter('smtpHost');
    }

    public static function getSmtpUsername()
    {
        return InstanceManager::getInstance()->getParameter('smtpUsername');
    }

    public static function getSmtpPassword()
    {
        return InstanceManager::getInstance()->getParameter('smtpPassword');
    }

    public static function getSmtpConnectionClass()
    {
        return InstanceManager::getInstance()->getParameter('smtpConnectionClass');
    }

    public static function getSendEmailsAfterDeploy()
    {
        return InstanceManager::getInstance()->getParameter('sendEmailsAfterDeploy');
    }

    public static function getModelProjectParent(Entities\Project $project = null){
        $modelProject = null;
        if ($project) {
            if ($project->getProjectType()->getExternaltype() == Entities\ProjectType::TYPE_PROJECT_CONTROL_MODEL_FREE
                ||  $project->getProjectType()->getExternaltype() == Entities\ProjectType::TYPE_PROJECT_CONTROL_MODEL_RESTRICTED ) {
                $modelProject = $project;
            } else {
                $modelProject = self::getModelProjectParent($project->getParent());
            }
        }
        return $modelProject;
    }

    /**
     * @param array[] $filters
     * @param $nameFilter
     * @param bool $remove
     * @return \DateTime|null
     */
    public static function getValueInFilterDataSourceByName(array &$filters,$nameFilter,$remove = false)
    {
        foreach ($filters as $key => $filter) {
            $name = $filter['columnName'];
            $values = $filter['value'];
            if($name == $nameFilter ){
                if($remove){
                    unset($filters[$key]);
                }
                return $values;
            }
        }
        return null;
    }

    public static function getArrayKeyUnpaired($array,$trim = true)
    {
        $pairArray = array();
        foreach ($array as $key => $element) {
            if ($key % 2) {
                $pairArray[] = $trim ? trim($element) : $element;
            }
        }
        return $pairArray;
    }

    public static function secondsToTime($seconds)
    {
        $time = '';
        $hours = $seconds / 3600;
        if ($hours >= 1) {
            $time .= floor($hours) . 'H';
        }
        $minutes = ($hours - floor($hours)) * 60;
        $seconds = ($minutes - floor($minutes)) * 60;
        $seconds = round($seconds);
        if ($seconds == 60) {
            $minutes += 1;
            $seconds = 0;
        }
        if ($minutes >= 1) {
            $time .= floor($minutes) . 'm';
        }
        if ($seconds >= 1) {
            $time .= $seconds . 's';
        }
        return $time;
    }

    public static function timeToSeconds($time,$withSeconds = true)
    {
        $time = strtoupper($time);
        $hourSeparator = strpos($time, 'H');
        $seconds = 0;
        if ($hourSeparator) {
            $seconds = intval(substr($time, 0, $hourSeparator)) * 3600;
        } else {
            $hourSeparator = -1;
        }
        $minuteSeparator = strpos($time, 'M');
        if ($minuteSeparator) {
            $seconds += intval(substr($time, $hourSeparator + 1, $minuteSeparator)) * 60;
        } else {
            $minuteSeparator = -1;
        }
        $secondSeparator = strpos($time, 'S');
        if ($withSeconds && $secondSeparator) {
            $seconds += intval(substr($time, $minuteSeparator + 1, $secondSeparator));
        }
        return $seconds;
    }

    public static function arrayControlRelationshipDevOps(){
        return array(
            Entities\ProjectType::TYPE_PROJECT_CONTROL_PRODUCT,
            Entities\ProjectType::TYPE_PROJECT_CONTROL_RELEASE,
            Entities\ProjectType::TYPE_PROJECT_CONTROL_SUB_RELEASE,
        );
    }

    public static function setPreFix(Entities\Task $task,$preFix = '[RLC] - '){
        $name = $task->getName();
        $pos = strpos($name, $preFix);
        if($pos === false || $pos > 0){
            $task->setName($preFix.$name);
        }
    }

    public static function fixBugSaveCurrencyMask($value){
        $value = str_replace('.','',$value);
        return str_replace(',','.',$value);
    }

    public static function getInArrayAssoc($arrayAssoc,$item,$index = 'ID'){
        $return = false;
        foreach ($arrayAssoc as $arrayItem) {
            if($arrayItem[$index] == $item){
                $return = $arrayItem;
                break;
            }
        }
        return $return;

    }

    public static function getResourceNameForSendingMail($issueId, $type){
        $entityManager = self::getEntityManager();
        $resourceName = '';
        /** @var Entities\Allocation $allocation */
        $allocation = $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR.'Allocation')
            ->findOneBy(array('task' => $issueId, 'type' =>  $type));
        if($allocation && $allocation->getResource()) {
            $resourceName = $allocation->getResource()->getName();
        }
        return $resourceName;
    }

    public static function getResourceIdByType($issueId, $type){
        $entityManager = self::getEntityManager();
        $resourceName = '';
        /** @var Entities\Allocation $allocation */
        $allocation = $entityManager->getRepository(self::PROJECT_MANAGEMENT_ENTITY_DIR.'Allocation')
            ->findOneBy(array('task' => $issueId, 'type' =>  $type));
        if($allocation && $allocation->getResource()) {
            $resourceName = $allocation->getResource()->getId();
        }
        return $resourceName;
    }

    /** copied from google */

    public static function convertNumberToWords($n)
    {

        $numeros[1][0] = '';
        $numeros[1][1] = 'um';
        $numeros[1][2] = 'dois';
        $numeros[1][3] = 'três';
        $numeros[1][4] = 'quatro';
        $numeros[1][5] = 'cinco';
        $numeros[1][6] = 'seis';
        $numeros[1][7] = 'sete';
        $numeros[1][8] = 'oito';
        $numeros[1][9] = 'nove';

        $numeros[2][0] = '';
        $numeros[2][10] = 'dez';
        $numeros[2][11] = 'onze';
        $numeros[2][12] = 'doze';
        $numeros[2][13] = 'treze';
        $numeros[2][14] = 'quatorze';
        $numeros[2][15] = 'quinze';
        $numeros[2][16] = 'dezesseis';
        $numeros[2][17] = 'dezesete';
        $numeros[2][18] = 'dezoito';
        $numeros[2][19] = 'dezenove';
        $numeros[2][2] = 'vinte';
        $numeros[2][3] = 'trinta';
        $numeros[2][4] = 'quarenta';
        $numeros[2][5] = 'cinquenta';
        $numeros[2][6] = 'sessenta';
        $numeros[2][7] = 'setenta';
        $numeros[2][8] = 'oitenta';
        $numeros[2][9] = 'noventa';

        $numeros[3][0] = '';
        $numeros[3][1] = 'cem';
        $numeros[3][2] = 'duzentos';
        $numeros[3][3] = 'trezentos';
        $numeros[3][4] = 'quatrocentos';
        $numeros[3][5] = 'quinhentos';
        $numeros[3][6] = 'seiscentos';
        $numeros[3][7] = 'setecentos';
        $numeros[3][8] = 'oitocentos';
        $numeros[3][9] = 'novecentos';

        $qtd = strlen($n);

        $compl[0] = ' mil ';
        $compl[1] = ' milhão ';
        $compl[2] = ' milhões ';
        $numero = "";
        $casa = $qtd;
        $pulaum = false;
        $x = 0;
        for ($y = 0; $y < $qtd; $y++) {

            if ($casa == 5) {

                if ($n[$x] == '1') {

                    $indice = '1' . $n[$x + 1];
                    $pulaum = true;
                } else {

                    $indice = $n[$x];
                }

                if ($n[$x] != '0') {

                    if (isset($n[$x - 1])) {

                        $numero .= ' e ';
                    }

                    $numero .= $numeros[2][$indice];

                    if ($pulaum) {

                        $numero .= ' ' . $compl[0];
                    }
                }
            }

            if ($casa == 4) {

                if (!$pulaum) {

                    if ($n[$x] != '0') {

                        if (isset($n[$x - 1])) {

                            $numero .= ' e ';
                        }
                    }
                }

                $numero .= $numeros[1][$n[$x]] . ' ' . $compl[0];
            }

            if ($casa == 3) {

                if ($n[$x] == '1' && $n[$x + 1] != '0') {

                    $numero .= 'cento ';
                } else {

                    if ($n[$x] != '0') {

                        if (isset($n[$x - 1])) {

                            $numero .= ' e ';
                        }

                        $numero .= $numeros[3][$n[$x]];
                    }
                }
            }

            if ($casa == 2) {

                if ($n[$x] == '1') {

                    $indice = '1' . $n[$x + 1];
                    $casa = 0;
                } else {

                    $indice = $n[$x];
                }

                if ($n[$x] != '0') {

                    if (isset($n[$x - 1])) {

                        $numero .= ' e ';
                    }

                    $numero .= $numeros[2][$indice];
                }
            }

            if ($casa == 1) {

                if ($n[$x] != '0') {
                    if ($numeros[1][$n[$x]] <= 10)
                        $numero .= ' ' . $numeros[1][$n[$x]];
                    else
                        $numero .= ' e ' . $numeros[1][$n[$x]];
                } else {

                    $numero .= '';
                }
            }

            if ($pulaum) {

                $casa--;
                $x++;
                $pulaum = false;
            }

            $casa--;
            $x++;
        }

        return $numero;
    }

    public static function convertCurrencyToWords($n){
        //Converte para o formato float
        if(strpos($n, ',') !== FALSE){
            $n = str_replace('.','',$n);
            $n = str_replace(',','.',$n);
        }

        //Separa o valor "reais" dos "centavos";
        $n = explode('.',$n);

        return ucfirst(self::convertNumberToWords($n[0])). ' reais' . ((isset($n[1]) && $n[1] > 0)?' e '.self::convertNumberToWords($n[1]).' centavos':'');

    }


    public static function setDataSetDefault(Request $request, Response $response, array $dataSet)
    {
        $response->addDataset(new \Zeedhi\Framework\DataSource\DataSet(explode('/', $request->getRoutePath())[1], $dataSet));
    }

    public static function removeRLCTag($taskName)
    {
        return substr($taskName, 8);
    }

    public static function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $limit . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $limit;
            }
        }
        return $query;
    }

    public static function parseDisplayedHourToSeconds($displayedHour)
    {
        $displayedHour = explode(":", $displayedHour);
        return $displayedHour[0] * 3600 + $displayedHour[1] * 60;
    }

    public static function parseSecondsToDisplayedHour($seconds)
    {
        $minutes = floor($seconds / 60);
        $hoursToString = floor($minutes / 60);
        $minutesToString = $minutes % 60;
        $minutesToString = (strlen($minutesToString) <= 1) ? '0' . $minutesToString : $minutesToString;
        $hoursToString = (strlen($hoursToString) <= 1) ? '0' . $hoursToString : $hoursToString;
        return ($seconds < 60) ? '00:' . $minutesToString : $hoursToString . ':' . $minutesToString;
    }

    public static function fixBugChartPie($dataSet,$indexSum,$indexLabel){
        $dataSetFixFug = array();
        foreach ($dataSet as $key => $row) {
            if($key <= 8){
                $dataSetFixFug[] = $row;
            }else{
                $dataSetFixFug[8][$indexLabel] = 'Others';
                $dataSetFixFug[8][$indexSum] += $row[$indexSum];
            }
        }
        return $dataSetFixFug;
    }

    public static function createArrayConditions($arrayValues)
    {
        $conditions = array();
        foreach ($arrayValues as $array) {
            $conditions[] = array(
                'columnName' => $array[0],
                'operator'   => $array[1],
                'value'      => $array[2]
            );
        }
        return $conditions;
    }

    public static function isArrayAssoc($array)
    {
        return array_keys($array) !== range(0, count($array) - 1);
    }

    public static function find($arryFind,$entity)
    {
        foreach ($arryFind as $find) {
            $entityName = $find['entity'];
            $method = $find['entity'];
            $entity = Utilities::getEntityManager()
                ->find($entityName,$entity->$method());
        }
        return $entity;
    }

    // --------------------------------------------------------------------- //
    const IV_SIZE = 16;
    const TEXT_SIZE = 32;


    /**
     * Pad the text
     *
     * Pad the text based on the normalization of string size to be encrypted
     *
     * @param $salt
     * @return string
     */
    protected static function padText($text, $size) {
        if (strlen($text) % $size)
            return str_pad($text, strlen($text) + $size - strlen($text) % $size, "\0");
        return $text;
    }

    protected static function getIv($cipher){
        return openssl_random_pseudo_bytes(openssl_cipher_iv_length($cipher));
    }

    private static function encodeEncryptedText($text, $iv){
        $iv_pos = rand(1, 15);
        $text = substr_replace($text, $iv, $iv_pos, 0);
        $iv_pos = dechex($iv_pos);
        $text = substr_replace($text, $iv_pos, 0, 0);
        $text = base64_encode($text);

        return $text;
    }

    /**
     * Encrypt data with salt.
     *
     * @param string $text Value to be encrypt.
     * @param string $salt Salt to be encrypt.
     *
     * @return string
     */
    public static function encrypt($text, $salt = 'libraries')
    {
        try{
            $cipher = "AES-256-CBC";
            $iv = self::getIv($cipher);
            $text = self::padText($text, 32);
            $text =
                openssl_encrypt(
                    $text,
                    $cipher,
                    $salt,
                    OPENSSL_NO_PADDING,
                    $iv
                );
            $text = self::encodeEncryptedText($text, $iv);

            return $text;
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    private static function decodeEncryptedText($text){
        $text = base64_decode($text);
        $iv_pos = hexdec($text[0])+1;
        $iv = substr($text, $iv_pos, self::IV_SIZE);
        $text_arr = explode($iv, $text);
        $text_arr[0] = substr($text_arr[0], 1);
        $text = implode('', $text_arr);
        $iv = self::padText($iv, self::IV_SIZE);

        return array('text'=> $text, 'iv'=>$iv);
    }

    /**
     * Decrypt data through salt.
     *
     * @param string $text Value to be decrypt.
     * @param string $salt Salt used in encryption.
     *
     * @return string
     */
    public static function decrypt($text, $salt = 'libraries')
    {
        try {
            $cipher = "AES-256-CBC";
            $decoded = self::decodeEncryptedText($text);

            $text =
                openssl_decrypt(
                    $decoded['text'],
                    $cipher,
                    $salt,
                    OPENSSL_NO_PADDING,
                    $decoded['iv']
                );
            $text = trim($text);
            return $text;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function downloadAndRemoveFile($fileDir, $fileName, $fileType = 'text/plain', $isRemoveFile = true)
    {
        if(strpos($fileDir, 'http') === false) {
            $fileSize = filesize($fileDir);
        } else {
            $fileSize = self::getRemoteFileSize($fileDir);
        }
        header('Accept-Ranges: none');
        header("Content-Type: " . $fileType . "; charset=ISO-8859-1");
        header("Content-Length: " . $fileSize);
        header("Content-Disposition: attachment; filename=" . $fileName);
        readfile($fileDir);

        if($isRemoveFile) {
            unlink($fileDir);
        }
        exit;
    }

    public static function selectHoracharHoradecByOracle($horaChar)
    {
        $query = "SELECT HORACHAR_HORADEC('$horaChar') AS HORADEC FROM DUAL";
        return self::getEntityManager()->getConnection()->fetchAll($query)[0]['HORADEC'];
    }

    public static function selectHoradecHoracharByOracle($horaDec)
    {
        $query = "SELECT HORADEC_HORACHAR($horaDec) AS HORACHAR FROM DUAL";
        return self::getEntityManager()->getConnection()->fetchAll($query)[0]['HORACHAR'];
    }

    public static function getNrParcNegocioByResourceId($resourceId)
    {
        $query = "SELECT OP.NRPARCNEGOCIO
                    FROM RESOURCE_T RE
                    JOIN OPERADOR   OP ON OP.CDOPERADOR = RE.EXTERNAL_CODE  
                   WHERE RE.ID = :RESOURCE_ID";
        $params = array(
            'RESOURCE_ID' => $resourceId
        );
        $data = self::getEntityManager()->getConnection()->fetchAll($query, $params);
        return empty($data) ? false : $data[0]['NRPARCNEGOCIO'];
    }

    public static function deleteAllFilesInFolder($path)
    {
        $files = glob($path . '/*');
        foreach($files as $file) {
            if(is_file($file)) {
                unlink($file);
            }
        }
    }

    public static function compactToZip($pathDir, $zipCreated)
    {
        $zip = new \ZipArchive;
        if($zip->open($zipCreated, \ZipArchive::CREATE ) === TRUE) {
            // Store the path into the variable
            $dir = opendir($pathDir);
            while($file = readdir($dir)) {
                if(is_file($pathDir.$file) ) {
                    $zip->addFile($pathDir.$file, $file);
                }
            }
            $zip->close();
        }
    }

    public  static  function compactToZipRecursive($source, $destination)
    {
        if (extension_loaded('zip')) {
            if (file_exists($source)) {
                $zip = new \ZipArchive();
                if ($zip->open($destination, \ZIPARCHIVE::CREATE)) {
                    $source = realpath($source);
                    if (is_dir($source)) {
                        $iterator = new \RecursiveDirectoryIterator($source);
                        // skip dot files while iterating
                        $iterator->setFlags(\RecursiveDirectoryIterator::SKIP_DOTS);
                        $files = new \RecursiveIteratorIterator($iterator, \RecursiveIteratorIterator::SELF_FIRST);
                        foreach ($files as $file) {
                            $file = realpath($file);
                            if (is_dir($file)) {
                                $zip->addEmptyDir(str_replace($source . '/', '', $file . '/'));
                            } else if (is_file($file)) {
                                $zip->addFromString(str_replace($source . '/', '', $file), file_get_contents($file));
                            }
                        }
                    } else if (is_file($source)) {
                        $zip->addFromString(basename($source), file_get_contents($source));
                    }
                }
                return $zip->close();
            }
        }
        return false;
    }

    public static function deleteDirectory($dir)
    {
        if (!file_exists($dir)) {
            return true;
        }
        if (!is_dir($dir)) {
            return unlink($dir);
        }

        foreach (scandir($dir) as $item) {
            if ($item == '.' || $item == '..') {
                continue;
            }
            if (!self::deleteDirectory($dir . DIRECTORY_SEPARATOR . $item)) {
                return false;
            }

        }
        return rmdir($dir);
    }

}
